# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   test
# FileName:      test_bpm.py
# Author:       xxxxx
# Datetime:     2024/12/28 10:16
# Description:
# 
# ---------------------------------------------------------------------------
import allure
import pytest

from APIAutoTest_3 import log_decorator
from APIAutoTest_3.common.read_excel import ReadExcel

case_datas = ReadExcel("jack").get_data()
print(case_datas,"--------------")

class TestBpm:
    @allure.epic("BPM-jack")
    @log_decorator
    @pytest.mark.parametrize("module, api, title, level, url, mime, req, case, expect, sql_type, sql, update", case_datas)
    def test_bpm(self, module, api, title, level, url, mime, req, case, expect, sql_type, sql, update,req_fix):
        allure.dynamic.feature(module)
        allure.dynamic.story(api)
        allure.dynamic.title(title)
        allure.dynamic.severity(level)

        res = req_fix.request_all(req_url=url, req_mime=mime, req_method=req, case_data=case, sql_type=sql_type,sql_data=sql, update_key=update)

        try:
            for key in expect:
                assert res.json().get(key) == expect[key]
        except AssertionError as e:
            raise AssertionError(f"用例{case}执行失败，预期结果与实际结果不一致，期望数据为{expect}，服务器返回数据为{res.txt}，错误信息为：{e}")
        except Exception as e:
            raise e
